<?php
/*
   2017 - v2 DNAS mods by djSpinnerCee - christopher.walker.11423@gmail.com
   cjw - http://djspinnercee.servemp3.com:11423/scStatus.html
*/

error_reporting(E_ERROR);	/* keep warnings from our output [cjw] */

require("dat/shoutcast.class2.php");
require("dat/geoip.php");
require("shoutcast-config2.php");

is_readable("dat/GeoIP.dat") or exit("Error: GeoIP.dat not found! http://geolite.maxmind.com/download/geoip/database/GeoLiteCountry/GeoIP.dat.gz");

function elapsedtime($seconds) {
        if ($seconds > 86400) {
                $seconds -= 86400;
                return(gmdate("j\d H:i:s", $seconds));
        } else
                return(gmdate("H:i:s", $seconds));
}

$listenersArray["Total"]["current"] = 0;
$listenersArray["Total"]["max"] = 0;

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
        <head>
                <title><?php echo $streamname ?> SHOUTcast status</title>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
                <meta http-equiv="cache-control" content="no-cache">
                <meta http-equiv="pragma" content="no-cache">
                <meta name="robots" content="index,nofollow">
                <link rel="shortcut icon" href="./favicon.ico">
                <link rel="stylesheet" type="text/css" href="style.css">
                <style type='text/css'>
                        <!--
                        body {background-color: #E1E1E1; color: black }
                        a { text-decoration: none; color:#000066 }
                        img { border:0 }
                        img.countryflags { border:0; width:18; height:12 }
                        table { border:none; width:80%; padding:2px }
                        table.main table { width:100% }
                        table.main.header, table.main.header td { text-align: center }
                        .header { text-align: center }
                        table td.title { background-color: #708fbe }
                        td.uid{ width:44px; text-align: center }
                        td.agent, td.connected, td.underruns { text-align: center }
                        td.host { text-align: center }
                        td.connected { width: 75px }
                        table.navmenu { border:thin dotted #708fbe; width:130px; padding: 0; text-align: center}
                        table.navmenu td { width: 50% }
                        table.navmenu td.flag { width:35%; text-align:right }
                        table.navmenu td.code { font-size: 11px; width:15%; text-align:left }
                        .footer { text-align: center; font-size: 11px }

                        -->
                </style>
                <script type="text/javascript">

                        /*
                                Floating Menu script-  Roy Whittle (http://www.javascript-fx.com/)
                                Script featured on/available at http://www.dynamicdrive.com/
                                This notice must stay intact for use
                        */

                        //Enter "frombottom" or "fromtop"
                        var verticalpos="fromtop"

                        function JSFX_FloatTopDiv() {
                                var startX = 3,
                                startY = 100;
                                var ns = (navigator.appName.indexOf("Netscape") != -1);
                                var d = document;
                                function ml(id) {
                                        var el=d.getElementById?d.getElementById(id):d.all?d.all[id]:d.layers[id];
                                        if(d.layers)el.style=el;
                                        el.sP=function(x,y){this.style.left=x;this.style.top=y;};
                                        el.x = startX;
                                        if (verticalpos=="fromtop")
                                                el.y = startY;
                                        else {
                                                el.y = ns ? pageYOffset + innerHeight : document.body.scrollTop + document.body.clientHeight;
                                                el.y -= startY;
                                        }
                                        return el;
                                }
                                window.stayTopLeft=function() {
                                        if (verticalpos=="fromtop") {
                                                var pY = ns ? pageYOffset : document.body.scrollTop;
                                                ftlObj.y += (pY + startY - ftlObj.y)/8;
                                        } else {
                                                var pY = ns ? pageYOffset + innerHeight : document.body.scrollTop + document.body.clientHeight;
                                                ftlObj.y += (pY - startY - ftlObj.y)/8;
                                        }
                                        ftlObj.sP(ftlObj.x, ftlObj.y);
                                        setTimeout("stayTopLeft()", 10);
                                }
                                ftlObj = ml("divStayTopLeft");
                                stayTopLeft();
                        }
                        onload = JSFX_FloatTopDiv;
                </script>
        </head>
        <body>
                <h2 id='Total' style='position:relative; top:15px; text-align:center'><?php echo $streamname ?> SHOUTcast relay status</h2>
                <div style='position:relative; left:135px; text-align: justify'>
                        <table class='main'>
                                <tr>
                                        <td>

    <center><font face="Verdana, Arial, Helvetica" size="1">
      Refresh:  <b id="countDownText"></b>
    </font> </center>

    <script language="JavaScript" type="text/javascript">
      var countDownInterval = 60;
      var countDownTime = countDownInterval + 1;

      if (document.all||document.getElementById)
        countDown();
      else
        window.onload = countDown;

      function countDown() {
        countDownTime--;
        if (countDownTime == 0) {
          countDownTime = countDownInterval;
          window.location.reload();
          return;
        }
        else if (countDownTime < 0)
          countDownTime = 30;
        if (document.all)
          document.all.countDownText.innerText = secsToMins(countDownTime);
        else if (document.getElementById)
          document.getElementById("countDownText").innerHTML = secsToMins(countDownTime);
        counter = setTimeout("countDown()", 1000);
      }

      function secsToMins(theValue) {
        var theMin = Math.floor(theValue / 60);
        var theSec = (theValue % 60);
        if (theSec < 10)
          theSec = "0" + theSec;
        return(theMin + ":" + theSec);
      }
    </script>

<?php
$gi = geoip_open("dat/GeoIP.dat", GEOIP_STANDARD);
for ($count = 0; $count < count($serv["host"]); $count++) {

        $shoutcast = new ShoutCast();
        $shoutcast->name = $serv["name"][$count];
        $shoutcast->host = $serv["host"][$count];
        $shoutcast->port = $serv["port"][$count];
        $shoutcast->passwd = $serv["passwd"][$count];
        $shoutcast->sid = $serv["sid"][$count];
/*    along with the sid, for v2 dnas we need to add params to urls [cjw] */

        if ($shoutcast->sid>0) {
           $v2info="?sid=".$shoutcast->sid;
           $v2xtra=":".$shoutcast->sid;
        } else {
           $v2info="";
           $v2xtra="";
        } 
        $listenersArray["$shoutcast->name"]["current"] = "NA";
        $listenersArray["$shoutcast->name"]["max"] = "NA";

        echo "<br>
              <table id=\"$shoutcast->name\" class='header'>
              <tr>
              <td class='title'>[<b>$shoutcast->name</b>] <b><a href=\"http://$shoutcast->host:$shoutcast->port/index.html".$v2info."\" target=\"_blank\">$shoutcast->host:$shoutcast->port$v2xtra</a></b> - ";
        if ($shoutcast->openstats()) {
                // We got the XML, gogogo!..
                if ($shoutcast->GetStreamStatus()) {
                        $listenersArray["$shoutcast->name"]["current"] = $shoutcast->GetCurrentListenersCount();
                        $listenersArray["$shoutcast->name"]["max"] = $shoutcast->GetMaxListenersCount();
                        $listenersArray["Total"]["current"] += $shoutcast->GetCurrentListenersCount();
                        $listenersArray["Total"]["max"] += $shoutcast->GetMaxListenersCount();
                        echo "<a href=\"".$shoutcast->GetServerURL()."\" target=\"_blank\">".$shoutcast->GetServerTitle()."</a></td>
                             </tr>
                             <tr>
                             <td>Currently ".$shoutcast->GetCurrentListenersCount()." out of "
                             .$shoutcast->GetMaxListenersCount()." people listening at "
                             .$shoutcast->GetBitRate()."Kbps, listener peak was "
                             .$shoutcast->GetPeakListenersCount()."</td>
                             </tr>
                             <tr>
                             <td>".$shoutcast->GetWebHitsCount()." webhits, ".$shoutcast->GetStreamHitsCount()." streamhits, average listen time is ".elapsedtime($shoutcast->GetAverageListenTime())."</td>
                             </tr>
                             <tr>
                             <td>Current Song: ".$shoutcast->GetCurrentSongTitle()."</td>
                             </tr>
                             </table>";
                                if ($count == 0 && $songhistorylimit > 0) {
                                $history = $shoutcast->GetSongHistory();
                                $histnum=sizeof($history);
                                $histnum++;
                                echo "<br>
                                     <table class='songhist'>
                                     <tr>
                                     <td colspan=2><b>Song history;</b>";
                                if ($histnum>$songhistorylimit) {
                                echo " <a href=\"http://$shoutcast->host:$shoutcast->port/played.html$v2info\" target=_blank>click here to see more ($histnum)</a>";
                                }
                                echo "</td>
                                     </tr>\n";
                                if (is_array($history)) {
                                        for ($i=0;$i<sizeof($history);$i++) {
                                                if ($i>=$songhistorylimit) break;
                                        echo "<tr>
                                             <td nowrap>[".date('H:i:sO', $history[$i]["playedat"])."]</td><td>".$history[$i]["title"]."</td>
                                             </tr>\n";
                                        }
                                } else {
                                        echo "
                                             <tr>
                                             <td colspan=2>No song history available..</td>
                                             </tr>";
                                }
                                echo" </table>
                                     <br>\n";
                        }

                        echo "<table class='listeners'>
                        <tr>
                        <td colspan=\"4\"><b>Listeners;</b></td>
                        </tr>\n";
                        $listeners = $shoutcast->GetListeners();
                        if (is_array($listeners)) {

                                echo "<tr class='header'>
                                <td class='title'>Uid</td>
                                <td class='title'>Host</td>
                                <td class='title'></td>
                                <td class='title'>Code</td>
                                <td class='title'>Countries</td>
                                <td class='title'>Agent</td>
                                <td class='title'>Connected</td>
                                <td class='title'>Underrun</td>
                                </tr>\n";
                                rsort($listeners);
                                $switch=false;
                                for ($i=0;$i<sizeof($listeners);$i++) {
                                        $country_id = geoip_country_id_by_name($gi, $listeners[$i]["hostname"]);
                                        $ip = $listeners[$i]["hostname"];
                                        $country_name = $GLOBALS['GEOIP_COUNTRY_NAMES'][$country_id];
                                        if (!$country_id) {
                                           $country_id = 0;
                                           $country_name = "Earth(?)";
                                        }
                                        $from["$country_id"]++;
                                        if ($switch == false)
                         {
                                $cellclass = 'tblRow0';
                                $switch = true;
                         }
                                else
                         {
                                $cellclass = 'tblRow1';
                                $switch = false;
                         }

                         echo "<tr align='center' class=".$cellclass.">
                               <td class='uid'>".$listeners[$i]["uid"]."</td>";
                         echo "<td class='host'><a href='http://www.speedguide.net/ip/$ip' target='_blank'>$ip</a></td>";
// the below didn't work, so added speedguide.net url to check ips [cjw]
// http://geotool.servehttp.com/?ip= 
                         if($country_id>0)
                            echo "<td class='nid'><img class='' src=\"flags/".$GLOBALS['GEOIP_COUNTRY_CODES'][$country_id].".gif\" alt=\"$country_name\"></td>";
                         else
                            echo "<td class='nid'>&nbsp;&nbsp;</td>";
                         echo "<td class='country_name'>".$GLOBALS['GEOIP_COUNTRY_CODES'][$country_id]."</td>
                               <td class='country_name'>".$GLOBALS[GEOIP_COUNTRY_NAMES][$country_id]."</td>
                               <td class='agent'>".$listeners[$i]["useragent"]."</td>
                               <td class='connected'>".elapsedtime($listeners[$i]["connecttime"])."</td>
                               <td class='underruns'>".$listeners[$i]["underruns"]."</td>
                               </tr>\n";


                                }
                        } else {
                                echo "<tr>
                                     <td colspan=\"2\">Noone listens right now..</td>
                                     </tr>\n";
                        }
                        echo "</table>\n";
                } else {
                        echo "Server is up, but no stream available..</td>
                             </tr>
                             </table>\n";
                }
        } else {
                // Ohhh, damnit..
                echo $shoutcast->geterror();
                echo "</td>\n </tr>\n  </table>\n";
        }
                echo " <br>\n";
}
geoip_close($gi);
?>
                         </td>
                         </tr>
                        </table>
                </div>
                <div id="divStayTopLeft" style="position:absolute">
                <table class='navmenu'>
                <tr>
                <td colspan="2" class='title'><b>Listeners</b></td>
                </tr>
<?php
if ($sort_navmenu == 1) {
        foreach ($listenersArray as $key => $row) {
                $current[$key] = $row['current'];
                $max[$key] = $row['max'];
        }
         array_multisort($current, SORT_NUMERIC, SORT_DESC, $max, SORT_NUMERIC, SORT_DESC, $listenersArray);
}
reset($listenersArray);
while (list($key, $val) = each($listenersArray))
                          echo "<tr>
                                <td><a href=\"#$key\">$key</a></td>
                                <td>".$listenersArray["$key"]["current"]."/".$listenersArray["$key"]["max"]."</td>
                                </tr>\n";
?>
                                </table>
                                <table class='navmenu'>
                                <tr>
                                <td colspan="3" class='title' title='Country statistics gathered using GeoIP'>Top <?php echo $countrylimit ?> Countries</td>
                                </tr>
<?php
arsort($from);
reset($from);
while (list($key, $val) = each($from)) {
        $country_code = $GLOBALS['GEOIP_COUNTRY_CODES']["$key"];
        $country_name = $GLOBALS['GEOIP_COUNTRY_NAMES']["$key"];
        if (!$country_code) {
                if (!$key && $key != 0) {
                        $country_code = $key;
                } else {
                        // I don't want to show unidentified hosts in ranking.
                        // $country_code = "N/A";
                        continue;
                }
        }
        echo "<tr title=\"$country_name\">
             <td class='flag'><img src=\"flags/$country_code.GIF\" alt=\"flag of the $country_name\"></td>
             <td class='code'>$country_code</td>
             <td>$val</td>
             </tr>\n";
        $countrycount++;
        if ($countrycount >= $countrylimit) break;
}
?>
</table>
</div>
<div class='footer'>
<a href="http://validator.w3.org/check?uri=referer" target="vWin">
<img src="http://www.w3.org/Icons/valid-html401 "alt="Valid HTML 4.01!" height="31" width="88">
</a><br>
</div>
</body>
</html>